// #autoload
// #name 	= _ZFlagCall
// #category 	= ZephyrFox's Scripts
// #description = Teamchats certain flag events.
// #version 	= 0.75
// #date 	= 01.17.2004
// #status 	= testing
// #author 	= Anthony Vrabel
// #warrior 	= ZephyrFox
// #email 	= ZephyrFox@hotmail.com
// #web 	= www.zephyrfox.com
// #credits 	= ProPack authors for the peakspeed idea, various other flag-call script authors for their ideas.
// #readme 	= _ZFlagCall.txt
// #config 	= ZFlagCallOPTGUI
// #include 	= support/callback.cs
// #include	= support/mission_callbacks.cs
// #include 	= support/loadout.cs
// #include 	= support/team_tracker.cs

package ZFCoverloads
{
	function PlayGui::onWake(%this)
	{
		parent::onWake(%this);

		updatePeakSpeed();
	}
};
if(isActivePackage(ZFCoverloads)) deactivatePackage(ZFCoverloads);
activatePackage(ZFCoverloads);


if(!isObject(ZFC))
{
	new ScriptObject(ZFC)
	{
		class 	= ZFC;
		version = "0.75";
	};
}

if(!isfile("stats/stats.txt"))
{
	%file = new FileObject();
	%file.openForWrite("stats/stats.txt");
	%file.writeLine("Stat files will go here.");
	%file.close();
	%file.delete();
}

function ZFC::setup(%this)
{
	callback.add(CallbackMSGCTFFlagTaken, "ZFC.flagTaken");
	callback.add(CallbackMSGCTFFlagDropped, "ZFC.flagDropped");
	callback.add(CallbackMSGCTFFlagCapped, "ZFC.flagCapped");

	callback.add(CallbackMSGCTFEnemyFlagTouch, "ZFC.enemyFlagTouch");

	callback.add(grenadeUsed, "ZFC.grenadeUsed");
	callback.add(RepairKitUsed, "ZFC.repKitUsed");

	callback.add(onGameOver, "ZFC.cleanup");
	callback.add(onUserClientDrop, "ZFC.cleanup");

	callback.add(CallbackLeaveMissionArea, "ZFC.leaveArea");
}

function updatePeakSpeed()
{
	if(isEventPending($pkSchedule)) cancel($pkSchedule);

	%speed = getControlObjectSpeed() * 3.6;

	if (%speed == 0) $pkSpeed = 0;
	else if ((%speed > $pkSpeed)) $pkSpeed = %speed;

	$pkSchedule = schedule(250, 0, updatePeakSpeed);
}

function ZFC::flagTaken(%this, %msgType, %msgString, %clientName, %flagTeam, %flagTeamId, %clientNameBase)
{
	if (deTag(%clientName) $= teamTracker.myName && $ZFCPref::flagTaken)
	{
		$mapName = MissionCallback.getMissionName();
		%gspeed = getControlObjectSpeed() * 3.6;
		if(%gspeed > $ZFC::recordGrabSpeed[$mapName]) $ZFC::recordGrabSpeed[$mapName] = %gspeed;

		if(loadout.getGrenadeType() $= "Flare Grenade") %flareCount = loadout.getGrenadeAmmo();
		else %flareCount = 0;

		$gotFlag = true;
		$ZephGrabTime = ZFC.getTime();
		$ZephHelp = schedule(3000, 0, "commandToServer", 'CannedChat', 'ChatHelp', false);

		if(loadout.getRepairKit() > 0) %message = "\c4Capper message: \c5Grabbed at \c1[" @ %gspeed @ " kph] \c5APPROACH peak \c1[" @ $pkSpeed @ " kph] \c5Flares Remaining \c1[" @ %flareCount @ "] \c5Repair Kit? \c1[YES]";
			else %message = "\c4Capper message: \c5Grabbed at \c1[" @ %gspeed @ " kph] \c5APPROACH peak \c1[" @ $pkSpeed @ " kph] \c5Flares Remaining \c1[" @ %flareCount @ "] \c5Repair Kit? \c1[NO]";
		commandToServer('TeamMessageSent', %message);	

		$pkSpeed = 0;
	}
}

function ZFC::flagCapped(%this, %msgType, %msgString, %clientName, %flagTeam, %flagTeamId, %clientNameBase)
{
	if(deTag(%clientName) $= teamTracker.myName && $ZFCPref::flagCapped)
	{
		$mapName = MissionCallback.getMissionName();
		%cspeed = getControlObjectSpeed() * 3.6;
		if(%cspeed > $ZFC::recordCapSpeed[$mapName]) $ZFC::recordCapSpeed[$mapName] = %cspeed;

		$gotFlag = false;
		$ZephCapTime = ZFC.getTime();
		%time = ($ZephCapTime-$ZephGrabTime)/1000;
		cancel($ZephHelp);

		%message = "\c4Capper message: \c5Capped at \c1[" @ %cspeed @ " kph] \c5in \c1[" @ %time @ " seconds] \c5RETURN peak \c1[" @ $pkSpeed @ " kph]";
		commandToServer('TeamMessageSent', %message);

		$pkSpeed = 0;
	}
}

function ZFC::flagDropped(%this, %msgType, %msgString, %clientName, %flagTeam, %flagTeamId, %clientNameBase)
{
	if(deTag(%clientName) $= teamTracker.myName && $ZFCPref::flagDropped)
	{
		$mapName = MissionCallback.getMissionName();
		%dspeed = getControlObjectSpeed() * 3.6;
		if(%dspeed > $ZFC::recordDropSpeed[$mapName]) $ZFC::recordDropSpeed[$mapName] = %dspeed;

		$gotFlag = false;
		cancel($ZephHelp);

		if(%dspeed > 0) %message = "\c4Capper message: \c5Flag passed!!!  Speed at pass \c1[" @ %dspeed @ " kph]";
			else %message = "\c4Capper message: \c5Get the NME flag!!!";
		commandToServer('TeamMessageSent', %message);

		$pkSpeed = 0;
	}
}

function ZFC::flagReturned(%this, %msgType, %msgString, %clientName, %flagTeam, %flagTeamId, %clientNameBase)
{
	if(deTag(%clientName) $= teamTracker.myName && $ZFCPref::flagReturned)
	{
		$mapName = MissionCallback.getMissionName();
		%rspeed = getControlObjectSpeed() * 3.6;
		if(%rspeed > $ZFC::recordReturnSpeed[$mapName]) $ZFC::recordReturnSpeed[$mapName] = %rspeed;

		$ZephRetTime = ZFC.getTime();
		%time = ($ZephRetTime-$NMEgrabTime)/1000;

		%message = "\c4LD message: \c5Returned at \c1[" @ %rspeed @ " kph] \c5within \c1[" @ %time @ " seconds] \c5of NME grab. RETRIEVE peak \c1[" @ $pkSpeed @ " kph]";
		commandToServer('TeamMessageSent', %message);

		$pkSpeed = 0;
	}
}

function ZFC::FCKill(%this, %msgType, %msgString, %killerName)
{
	if(Strstr(%msgString, "You received") != -1 && $ZFCPref::FCkilled)
	{
		$mapName = MissionCallback.getMissionName();
		%fckspeed = getControlObjectSpeed() * 3.6;
		if(%fckspeed > $ZFC::recordFCKSpeed[$mapName]) $ZFC::recordFCKSpeed[$mapName] = %fckspeed;

		$ZephFCKTime = ZFC.getTime();
		%time = ($ZephFCKTime-$NMEgrabTime)/1000;

		%message = "\c4LD message: \c5NME FC killed at \c1[" @ %fckspeed @ " kph] \c5within \c1[" @ %time @ " seconds] \c5of NME grab. INTERCEPT peak \c1[" @ $pkSpeed @ " kph]";
		commandToServer('TeamMessageSent', %message);

		$pkSpeed = 0;
	}
}

function ZFE::enemyFlagTouch(%this, %msgType, %msgString, %toucher, %score, %plural)
{
	$NMEgrabTime = ZFC.getTime();
}

function ZFC::grenadeUsed(%this)
{
	if(loadout.getGrenadeType() $= "Flare Grenade") $ZFCflareCount = loadout.getGrenadeAmmo();
	else $ZFCflareCount = 0;
	$ZFCbeacons = loadout.getBeaconAmmo();

	if($ZFCflareCount == 0 && $ZFCrepkits == 0 && $ZFCbeacons == 0) return;

	if($gotFlag && $ZFCPref::FCflares)
	{
		if($ZFCflareCount > 0)
		{
			%message = "\c4Capper message: \c5Flares remaining \c1[" @ $ZFCflareCount @ "]";
			commandToServer('TeamMessageSent', %message);
		}
		else
		{
			%message = "\c4Capper message: \c5*** Flared out! ***";
			commandToServer('TeamMessageSent', %message);
		}
	}
}

function ZFC::repKitUsed(%this)
{
	$ZFCrepkits = loadout.getRepairKit();
	$ZFCbeacons = loadout.getBeaconAmmo();

	if($ZFCflareCount == 0 && $ZFCrepkits == 0 && $ZFCbeacons == 0) return;

	if($gotFlag && $ZFCPref::FCrepkit)
	{
		%message = "\c4Capper message: \c5Repair kit used!";
		commandToServer('TeamMessageSent', %message);
	}
}

function ZFC::leaveArea(%this)
{
	$gotFlag = false;
}

function ZFC::cleanup(%this)
{
	ZFC.saveStats();

	$gotFlag = false;
	$ZFCrepkits = 0;
	$ZFCflarecount = 0;
	$ZFCbeaconcount = 0;
}

function ZFC::getTime(%this)
{
	return mFloor(getSimTime());
}

function ZFC::loadStats()
{
	if(!$ZFC::loaded)
	{
		exec("stats/ZFCstats.stats");
		$ZFC::loaded = 1;
	}
}

function ZFC::saveStats()
{
	export("$ZFCPrefs::*", "stats/ZFCstats.stats", false);
}

function ZFC::loadPrefs()
{
	if(!$ZFCPref::loaded)
	{
		exec("prefs/ZFC_Prefs.cs");
		$ZFCPref::loaded = 1;
	}
}

function ZFC::savePrefs()
{
	export("$ZFCPref::*", "prefs/ZFC_Prefs.cs", false);
}

ZFC.loadStats();
ZFC.loadPrefs();
ZFC.setup();

function ZFlagCallOPTGUI::onWake(%this)
{
	%Hres = getWord($pref::Video::resolution, 0);

	switch(%Hres)
	{
		case 1600:	%HGUIext = 1360;
				%VGUIext = 1073;

				%HPANext = 1340;
				%VPANext = 1053;

				%HSCRext = 1310;
				%VSCRext = 1013;

				%HCONext = 1285;
				%VCONext = 988;

		case 1280:	%HGUIext = 1040;
				%VGUIext = 897;

				%HPANext = 1020;
				%VPANext = 877;

				%HSCRext = 990;
				%VSCRext = 837;

				%HCONext = 965;
				%VCONext = 812;

		case 1024:	%HGUIext = 784;
				%VGUIext = 641;

				%HPANext = 764;
				%VPANext = 621;

				%HSCRext = 734;
				%VSCRext = 581;

				%HCONext = 709;
				%VCONext = 556;

		case 800:	%HGUIext = 560;
				%VGUIext = 473;

				%HPANext = 540;
				%VPANext = 453;

				%HSCRext = 510;
				%VSCRext = 413;

				%HCONext = 485;
				%VCONext = 388;

		default:	%HGUIext = 784;
				%VGUIext = 641;

				%HPANext = 764;
				%VPANext = 621;

				%HSCRext = 734;
				%VSCRext = 581;

				%HCONext = 709;
				%VCONext = 556;
	}

	ZFlagCallOPTGUI.setExtent(%HGUIext, %VGUIext);
	ZFlagCallOPTPane.setExtent(%HPANext, %VPANext);
	ZFlagCallOPTScroll.setExtent(%HSCRext, %VSCRext);
	ZFlagCallOPTContent.setExtent(%HCONext, %VCONext);
}

//--- OBJECT WRITE BEGIN ---
new GuiControl(ZFlagCallOPTGUI) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "5 12";
	extent = "0 0";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(ZFlagCallOPTPane) {
		profile = "ShellPaneProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "0 0";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "ZFlagCall Options";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";
	};
	new ShellScrollCtrl(ZFlagCallOPTScroll) {
		profile = "NewScrollCtrlProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "15 25";
		extent = "0 0";
		minExtent = "24 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		willFirstRespond = "1";
		hScrollBar = "dynamic";
		vScrollBar = "dynamic";
		constantThumbHeight = "0";
		defaultLineHeight = "15";
		childMargin = "0 0";
		fieldBase = "gui/shll_field";

		new GuiScrollContentCtrl(ZFlagCallOPTContent) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "4 4";
			extent = "0 0";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiControl(ZFlagCallOPTCanvas) {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "1280 1024";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

				new ShellToggleButton() {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "10 20";
					extent = "170 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZFCPref::flagTaken";
					helpTag = "0";
					text = "Enable flag grab message";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton() {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "10 45";
					extent = "170 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZFCPref::flagCapped";
					helpTag = "0";
					text = "Enable flag cap message";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton() {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "10 70";
					extent = "170 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZFCPref::flagDropped";
					helpTag = "0";
					text = "Enable flag dropped message";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton() {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "10 95";
					extent = "170 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZFCPref::flagReturned";
					helpTag = "0";
					text = "Enable flag return message";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton() {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "10 120";
					extent = "170 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZFCPref::FCkilled";
					helpTag = "0";
					text = "Enable FC killed message";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton() {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "10 145";
					extent = "170 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZFCPref::FCflares";
					helpTag = "0";
					text = "Enable flare messages";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton() {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "10 170";
					extent = "170 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZFCPref::FCrepkit";
					helpTag = "0";
					text = "Enable repkit messages";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellBitmapButton() {
					profile = "ShellButtonProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "7 195";
					extent = "100 38";
					minExtent = "32 38";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					command = "ZFC.savePrefs();";
					helpTag = "0";
					text = "Save";
					simpleStyle = "0";
				};
			};
		};
	};
};
//--- OBJECT WRITE END ---